From f68b35591cd915e1ef273d9f6317ff28dc241bc7 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Fri, 3 Feb 2012 13:49:40 -0600
Subject: Interconnecting Screens.

---
 grade/report/quick_edit/classes/lib.php            |   56 +++++++++++++++-
 grade/report/quick_edit/index.php                  |   28 +++++---
 .../quick_edit/lang/en/gradereport_quick_edit.php  |    5 ++
 grade/report/quick_edit/lib.php                    |    6 ++
 grade/report/quick_edit/screens/grade/lib.php      |    2 +-
 grade/report/quick_edit/screens/select/lib.php     |    4 +-
 grade/report/quick_edit/screens/user/lib.php       |   74 ++++++++++++++++++++
 7 files changed, 161 insertions(+), 14 deletions(-)

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index c85021a..78636b0 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -19,6 +19,21 @@ abstract class quick_edit_screen {
         $this->init();
     }
 
+    public function format_link($screen, $itemid, $display = null) {
+        $url = new moodle_url('/grade/report/quick_edit/index.php', array(
+            'id' => $this->courseid,
+            'item' => $screen,
+            'itemid' => $itemid,
+            'group' => $this->groupid
+        ));
+
+        if ($display) {
+            return html_writer::link($url, $display);
+        } else {
+            return $url;
+        }
+    }
+
     public function format_range($item) {
         $decimals = $item->get_decimals();
 
@@ -28,6 +43,43 @@ abstract class quick_edit_screen {
         return "$min - $max";
     }
 
+    public function format_override($item, $grade) {
+        if ($item->itemtype == 'manual') {
+            return get_string('notavailable', 'gradereport_quick_edit');
+        }
+
+        return $this->checkbox_attribute($grade, 'override', $grade->is_overridden());
+    }
+
+    public function format_exclude($item, $grade) {
+        return $this->checkbox_attribute($grade, 'excldue', $grade->is_excluded());
+    }
+
+    private function checkbox_attribute($grade, $post_name, $is_checked) {
+        $name = $post_name . '_' . $grade->itemid . '_' . $grade->userid;
+
+        $attributes = array(
+            'type' => 'checkbox',
+            'name' => $name,
+            'value' => 1
+        );
+
+        $hidden = array(
+            'type' => 'hidden',
+            'name' => 'old' . $name
+        );
+
+        if ($is_checked) {
+            $attributes['checked'] = 'CHECKED';
+            $hidden['value'] = 1;
+        }
+
+        return (
+            html_writer::empty_tag('input', $attributes) .
+            html_writer::empty_tag('input', $hidden)
+        );
+    }
+
     public function format_grade($grade, $decimals) {
         $name = 'grade_' . $grade->itemid . '_' . $grade->userid;
 
@@ -78,7 +130,9 @@ abstract class quick_edit_screen {
         );
     }
 
-    public abstract function heading();
+    public function heading() {
+        return get_string('pluginname', 'gradereport_quick_edit');
+    }
 
     public abstract function init();
 
diff --git a/grade/report/quick_edit/index.php b/grade/report/quick_edit/index.php
index 6e230d4..3f11e5b 100755
--- a/grade/report/quick_edit/index.php
+++ b/grade/report/quick_edit/index.php
@@ -39,7 +39,9 @@ $PAGE->set_url(new moodle_url('/grade/report/quick_edit/index.php', array(
     'group' => $groupid
 )));
 
-if (!$course = $DB->get_record('course', array('id' => $courseid))) {
+$course_params = array('id' => $courseid);
+
+if (!$course = $DB->get_record('course', $course_params)) {
     print_error('nocourseid');
 }
 
@@ -61,22 +63,30 @@ $gpr = new grade_plugin_return(array(
     'type' => 'report', 'plugin' => 'quick_edit', 'courseid' => $courseid
 ));
 
-if (!isset($USER->grade_last_report)) {
-    $USER->grade_last_report = array();
-}
-$USER->grade_last_report[$course->id] = 'quick_edit';
-
 grade_regrade_final_grades($courseid);
 
-$PAGE->set_context($context);
-
 $report = new grade_report_quick_edit(
     $courseid, $gpr, $context, $itemtype, $itemid, $groupid
 );
 
 $reportname = $report->screen->heading();
 
-print_grade_page_head($course->id, 'report', 'quick_edit', $reportname, false);
+$pluginname = get_string('pluginname', 'gradereport_quick_edit');
+
+$report_url = new moodle_url('/grade/report/index.php', $course_params);
+$edit_url = new moodle_url('/grade/report/quick_edit/index.php', $course_params);
+
+$PAGE->navbar->add(get_string('gradeadministration', 'grades'));
+$PAGE->navbar->add(get_string('pluginname', 'gradereport_grader'), $report_url);
+
+if ($reportname != $pluginname) {
+    $PAGE->navbar->add($pluginname, $edit_url);
+    $PAGE->navbar->add($reportname);
+} else {
+    $PAGE->navbar->add($pluginname);
+}
+
+print_grade_page_head($course->id, 'report', 'quick_edit', $reportname);
 
 echo $report->output();
 
diff --git a/grade/report/quick_edit/lang/en/gradereport_quick_edit.php b/grade/report/quick_edit/lang/en/gradereport_quick_edit.php
index 45361b2..a157bf7 100755
--- a/grade/report/quick_edit/lang/en/gradereport_quick_edit.php
+++ b/grade/report/quick_edit/lang/en/gradereport_quick_edit.php
@@ -26,5 +26,10 @@
 $string['pluginname'] = 'Quick Edit';
 $string['quick_edit:view'] = 'View the '.$string['pluginname'].' report';
 
+$string['exclude'] = 'Exclude';
+$string['override'] = 'Override';
+$string['assessmentname'] = 'Assessment Name';
+$string['notavailable'] = 'NA';
+
 // Error Strings
 $string['notvalid'] = 'Not a valid Quick Edit screen: {$a}';
diff --git a/grade/report/quick_edit/lib.php b/grade/report/quick_edit/lib.php
index 30414c7..d136324 100755
--- a/grade/report/quick_edit/lib.php
+++ b/grade/report/quick_edit/lib.php
@@ -56,6 +56,12 @@ class grade_report_quick_edit extends grade_report {
         return 'quick_edit_' . $screen;
     }
 
+    public static function only_items() {
+        return function($item) {
+            return $item->itemtype != 'course' and $item->itemtype != 'category';
+        };
+    }
+
     function process_data($data) {
     }
 
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
index 9b3ba16..51a5507 100644
--- a/grade/report/quick_edit/screens/grade/lib.php
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -54,7 +54,7 @@ class quick_edit_grade extends quick_edit_screen {
 
         return array(
             $OUTPUT->user_picture($user),
-            $fullname,
+            $this->format_link('user', $user->id, $fullname),
             $this->item_range(),
             $this->format_grade($grade, $this->item->get_decimals()),
             $this->format_feedback($grade)
diff --git a/grade/report/quick_edit/screens/select/lib.php b/grade/report/quick_edit/screens/select/lib.php
index 413fb20..be87f26 100644
--- a/grade/report/quick_edit/screens/select/lib.php
+++ b/grade/report/quick_edit/screens/select/lib.php
@@ -7,9 +7,7 @@ class quick_edit_select extends quick_edit_screen {
 
         $params = array('courseid' => $this->courseid);
 
-        $filter_items = function($item) {
-            return $item->itemtype != 'course' and $item->itemtype != 'category';
-        };
+        $filter_items = grade_report_quick_edit::only_items();
 
         $this->grade_items = array_filter(grade_item::fetch_all($params), $filter_items);
 
diff --git a/grade/report/quick_edit/screens/user/lib.php b/grade/report/quick_edit/screens/user/lib.php
index f954812..6f6c469 100644
--- a/grade/report/quick_edit/screens/user/lib.php
+++ b/grade/report/quick_edit/screens/user/lib.php
@@ -1,4 +1,78 @@
 <?php
 
 class quick_edit_user extends quick_edit_screen {
+
+    private $categories = array();
+
+    public function init() {
+        global $DB;
+
+        $this->user = $DB->get_record('user', array('id' => $this->itemid));
+
+        $params = array('courseid' => $this->courseid);
+
+        $filter_items = grade_report_quick_edit::only_items();
+
+        $this->grade_items = array_filter(grade_item::fetch_all($params), $filter_items);
+    }
+
+    public function html() {
+        $table = new html_table();
+
+        $table->head = $this->headers();
+
+        $table->data = array();
+
+        foreach ($this->grade_items as $item) {
+            $table->data[] = $this->format_line($item);
+        }
+
+        return html_writer::table($table);
+    }
+
+    public function headers() {
+        return array(
+            '',
+            get_string('assessmentname', 'gradereport_quick_edit'),
+            get_string('gradecategory', 'grades'),
+            get_string('range', 'grades'),
+            get_string('grade', 'grades'),
+            get_string('feedback', 'grades'),
+            get_string('override', 'gradereport_quick_edit'),
+            get_string('exclude', 'gradereport_quick_edit')
+        );
+    }
+
+    public function format_line($item) {
+        global $OUTPUT;
+
+        $grade = grade_grade::fetch(array(
+            'itemid' => $item->id, 'userid' => $this->user->id
+        ));
+
+        return array(
+            $OUTPUT->pix_icon('t/' . $item->itemtype . '_item', $item->itemname),
+            $this->format_link('grade', $item->id, $item->itemname),
+            $this->category($item)->get_name(),
+            $this->format_range($item),
+            $this->format_grade($grade, $item->get_decimals()),
+            $this->format_feedback($grade),
+            $this->format_override($item, $grade),
+            $this->format_exclude($item, $grade)
+        );
+    }
+
+    private function category($item) {
+        if (!isset($this->categories[$item->categoryid])) {
+            $category = $item->get_parent_category();
+
+            $this->categories[$category->id] = $category;
+        }
+
+        return $this->categories[$item->categoryid];
+    }
+
+    public function heading() {
+        return fullname($this->user);
+    }
 }
-- 
1.7.1


